<template>
  <l-map
    :zoom="zoom"
    :center="center"
    :options="mapOptions"
    @update:center="centerUpdate"
    @update:zoom="zoomUpdate"
  >
    <l-tile-layer
      :url="url"
      :attribution="attribution"
    />
    <l-marker :lat-lng="withPopup">
      <l-popup>
        <div @click="innerClick">
          I am a popup
          <p v-show="showParagraph">
            Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque
            sed pretium nisl, ut sagittis sapien. Sed vel sollicitudin nisi.
            Donec finibus semper metus id malesuada.
          </p>
        </div>
      </l-popup>
    </l-marker>
    <l-marker :lat-lng="withTooltip">
      <l-tooltip :options="{ permanent: true, interactive: true }">
        <div @click="innerClick">
          I am a tooltip
          <p v-show="showParagraph">
            Lorem ipsum dolor sit amet, consectetur adipiscing elit. Quisque
            sed pretium nisl, ut sagittis sapien. Sed vel sollicitudin nisi.
            Donec finibus semper metus id malesuada.
          </p>
        </div>
      </l-tooltip>
    </l-marker>
    <l-circle-marker
      v-for="[idx, marker] in markers.entries()"
      v-bind:key="`marker_${idx}`"
      :radius="4"
      :color="marker.color"
      :lat-lng="marker.latlngs"
      :fill=true
      :fillOpacity=1.0
    ></l-circle-marker>
    <l-polyline
      v-for="[idx, polyline] in polylines.entries()"
      v-bind:key="`poly_${idx}`"
      :lat-lngs="polyline.latlngs"
      :color="polyline.color">
    </l-polyline>
  </l-map>
</template>

<script lang="ts">
import Vue from 'vue';
import colors from 'vuetify/lib/util/colors';
import {
  LatLng,
  Map,
  latLng,
} from 'leaflet';
import {
  LMap,
  LTileLayer,
  LMarker,
  LPopup,
  LPolyline,
  LTooltip,
  LCircleMarker,
} from 'vue2-leaflet';

export default Vue.extend({
  name: 'Map',
  components: {
    LMap,
    LTileLayer,
    LMarker,
    LCircleMarker,
    LPopup,
    LTooltip,
    LPolyline,
  },
  data() {
    return {
      mapObject: undefined as Map | undefined,
      zoom: 13,
      center: latLng(43.604877, 1.464606),
      url: 'https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png',
      attribution:
        '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors',
      currentZoom: 11.5,
      currentCenter: latLng(43.604877, 1.464606),
      showParagraph: false,
      mapOptions: {
        zoomSnap: 0.5,
      },
      markers: [] as { latlngs: LatLng; color?: string }[],
      polylines: [] as { latlngs: LatLng[]; color: string }[],
      withPopup: latLng(43.608047, 1.456416),
      withTooltip: latLng(43.603867, 1.455558),
      jsonData: {
        type: 'FeatureCollection',
        features: [
          {
            bbox: [
              8.681436,
              49.41461,
              8.690123,
              49.420514,
            ],
            type: 'Feature',
            properties: {
              segments: [
                {
                  distance: 1322.8,
                  duration: 305,
                  steps: [
                    {
                      distance: 413.4,
                      duration: 99.2,
                      type: 11,
                      instruction: 'Head north on Wielandtstraße',
                      name: 'Wielandtstraße',
                      wayPoints: [
                        0,
                        15,
                      ],
                    },
                    {
                      distance: 130,
                      duration: 31.2,
                      type: 1,
                      instruction: 'Turn right onto Seitzstraße',
                      name: 'Seitzstraße',
                      wayPoints: [
                        15,
                        18,
                      ],
                    },
                    {
                      distance: 54.3,
                      duration: 13,
                      type: 0,
                      instruction: 'Turn left onto Quinckestraße',
                      name: 'Quinckestraße',
                      wayPoints: [
                        18,
                        21,
                      ],
                    },
                    {
                      distance: 511.5,
                      duration: 122.8,
                      type: 1,
                      instruction: 'Turn right onto Moltkestraße',
                      name: 'Moltkestraße',
                      wayPoints: [
                        21,
                        35,
                      ],
                    },
                    {
                      distance: 83,
                      duration: 7.5,
                      type: 0,
                      instruction: 'Turn left onto Handschuhsheimer Landstraße, B 3',
                      name: 'Handschuhsheimer Landstraße, B 3',
                      wayPoints: [
                        35,
                        37,
                      ],
                    },
                    {
                      distance: 130.6,
                      duration: 31.4,
                      type: 0,
                      instruction: 'Turn left onto Roonstraße',
                      name: 'Roonstraße',
                      wayPoints: [
                        37,
                        40,
                      ],
                    },
                    {
                      distance: 0,
                      duration: 0,
                      type: 10,
                      instruction: 'Arrive at Roonstraße, straight ahead',
                      name: '-',
                      wayPoints: [
                        40,
                        40,
                      ],
                    },
                  ],
                },
              ],
              summary: {
                distance: 1322.8,
                duration: 305,
              },
              wayPoints: [
                0,
                40,
              ],
            },
            geometry: {
              coordinates: [
                [
                  8.681496,
                  49.41461,
                ],
                [
                  8.68149,
                  49.414711,
                ],
                [
                  8.681441,
                  49.415655,
                ],
                [
                  8.681436,
                  49.415747,
                ],
                [
                  8.681455,
                  49.415835,
                ],
                [
                  8.681509,
                  49.416087,
                ],
                [
                  8.681642,
                  49.416498,
                ],
                [
                  8.681671,
                  49.416588,
                ],
                [
                  8.681701,
                  49.416684,
                ],
                [
                  8.681875,
                  49.417287,
                ],
                [
                  8.68189,
                  49.417394,
                ],
                [
                  8.681868,
                  49.417475,
                ],
                [
                  8.681865,
                  49.41748,
                ],
                [
                  8.681775,
                  49.417627,
                ],
                [
                  8.681573,
                  49.418169,
                ],
                [
                  8.681536,
                  49.418268,
                ],
                [
                  8.681659,
                  49.418292,
                ],
                [
                  8.683161,
                  49.418548,
                ],
                [
                  8.683276,
                  49.41856,
                ],
                [
                  8.683257,
                  49.418636,
                ],
                [
                  8.683168,
                  49.418995,
                ],
                [
                  8.683157,
                  49.419042,
                ],
                [
                  8.683291,
                  49.419058,
                ],
                [
                  8.684872,
                  49.419242,
                ],
                [
                  8.68501,
                  49.419258,
                ],
                [
                  8.685156,
                  49.419273,
                ],
                [
                  8.686408,
                  49.419402,
                ],
                [
                  8.68651,
                  49.419413,
                ],
                [
                  8.686617,
                  49.419425,
                ],
                [
                  8.686983,
                  49.419461,
                ],
                [
                  8.687101,
                  49.419473,
                ],
                [
                  8.687212,
                  49.419486,
                ],
                [
                  8.688301,
                  49.419619,
                ],
                [
                  8.688398,
                  49.41963,
                ],
                [
                  8.690104,
                  49.419828,
                ],
                [
                  8.690123,
                  49.419833,
                ],
                [
                  8.689854,
                  49.420216,
                ],
                [
                  8.689652,
                  49.420514,
                ],
                [
                  8.68963,
                  49.42051,
                ],
                [
                  8.688601,
                  49.420393,
                ],
                [
                  8.687872,
                  49.420318,
                ],
              ],
              type: 'LineString',
            },
          },
        ],
        bbox: [
          8.681436,
          49.41461,
          8.690123,
          49.420514,
        ],
        metadata: {
          attribution: 'openrouteservice.org | OpenStreetMap contributors',
          service: 'routing',
          timestamp: 1587896316766,
          query: {
            coordinates: [
              [
                8.681495,
                49.41461,
              ],
              [
                8.687872,
                49.420318,
              ],
            ],
            profile: 'driving-car',
            format: 'json',
          },
          engine: {
            version: '6.1.0',
            buildDate: '2020-04-20T02:27:36Z',
            graphDate: '2020-04-06T00:00:00Z',
          },
        },
      },
    };
  },
  methods: {
    zoomUpdate(zoom: number) {
      this.currentZoom = zoom;
    },
    centerUpdate(center: LatLng) {
      this.currentCenter = center;
    },
    innerClick() {
      const { features: [{ geometry: { coordinates } }] } = this.jsonData;
      const polyline = {
        latlngs: [] as LatLng[],
        color: 'red',
      };
      coordinates.forEach((coordinate) => {
        this.markers.push({
          latlngs: new LatLng(coordinate[1], coordinate[0]),
          color: colors.blue.base,
        });
        polyline.latlngs.push(new LatLng(coordinate[1], coordinate[0]));
      });
      this.polylines.push(polyline);
    },
  },
});
</script>
